/*! phoscon-app 2024-10-07 */

import{injectSwitchWizzardSvg}from"./devices/load-svg.js";import{getPageContent,translatePage}from"./devices/load-page.js";import{getScanStates}from"./devices/scan-states.js";import{initMachine}from"./devices/machine.js";import{createMachineContent}from"./devices/make-machine.js";import{actions as pageActions}from"./devices/machine-actions.js";import{START_SCAN,STOP_SCAN,DEVICE_ADDED,DEVICE_UPDATED,DEVICE_NO_UPDATED,NO_DEVICE_ADDED}from"./devices/scan-states.js";import{addClassToAll,removeClassToAll,callFunc}from"./devices/generic-helper-functions.js";import*as c from"./devices/constants.js";import*as s from"./devices/scan-states.js";import*as scanActions from"./devices/scan-actions.js";import*as scanFunctions from"./devices/scan-functions.js";import{initPages}from"./devices-sensors/map.js";import{initOverview}from"./devices-sensors/overview-view.js";import{initDetailsView}from"./devices-sensors/details-view.js";import{initDevicesSensorView}from"./devices-sensors/devices-sensors-view.js";const{Machine:Machine}=XState,{interpret:interpret}=XStateInterpreter;function setShadowClass(el){el.classList[el.scrollTop>10?"add":"remove"]("shadow-top"),el.classList[el.scrollHeight-el.clientHeight-el.scrollTop>10?"add":"remove"]("shadow-bottom")}async function initViewAndLogic(){screenMin(SCREEN_MIN_WIDTH_TABLET_PORTRAIT)&&openNav();const pageParams={constants:c,scanStates:s},pages=initPages(pageParams),generalViews=initOverview(c,injectSwitchWizzardSvg),detailsView=initDetailsView(c,injectSwitchWizzardSvg),view=initDevicesSensorView(addClassToAll,removeClassToAll,injectSwitchWizzardSvg),states=await createMachineContent(pages,c,null),scanStates=await getScanStates(scanActions),functions=await getMachineFunctions(scanFunctions,getPageContent,translatePage),actions=await getPageActions(pageActions);generalViews.detailsView=detailsView;let context={overviewInitial:"table",...functions,callFunc:callFunc,generalViews:generalViews,pageParams:pageParams,view:view,constants:{...c,START_SCAN:START_SCAN,STOP_SCAN:STOP_SCAN,DEVICE_ADDED:DEVICE_ADDED,DEVICE_UPDATED:DEVICE_UPDATED,DEVICE_NO_UPDATED:DEVICE_NO_UPDATED,NO_DEVICE_ADDED:NO_DEVICE_ADDED},noteSn:{}},pagesStates={id:"pages",initial:"page-init",states:states};const machine=await initMachine(pagesStates,scanStates,actions,Machine,interpret,context),service=machine.context.service;view.service=service,generalViews.tableView.views.forEach(view=>{view.service=service},this);const navItem=document.querySelector("#dSensor2").parentElement;navItem.addEventListener("click",function(){app.router.navigate("table",{trigger:!0})}),app.headLeftBtn=document.querySelector(".header #menu-btn"),app.headLeftSvg=app.headLeftBtn.querySelector("use"),app.headLeftLabel=app.headLeftBtn.querySelector("span"),app.deviceScrollContainers=document.querySelectorAll(".dev-scroll-cont");var Router=Backbone.Router.extend({routes:{"table/wizard/:page":"showSensorWizard","sensor/:id":"showSensorDetails",table:"showSensorTable"},showSensorDetails:function(id){navItem.classList.add("sub-item");let sn=app.sensors.get(id);sn&&service.send({type:"DETAILS",model:sn}),screenMax(SCREEN_MAX_WIDTH_PHONE_LANDSCAPE)&&isThisPortrait()&&(app.headLeftSvg.setAttribute("xlink:href","#back-icon-sm"),app.headLeftLabel.textContent=translate("link_sensors")),generalViews.details&&setContextMenuListener(generalViews.details.el)},showSensorTable:function(url){navItem.classList.remove("sub-item"),app.headLeftSvg.setAttribute("xlink:href","#icon-hamburger-sm"),app.session.snid=void 0,app.session.mac=void 0,app.deviceScrollContainers.forEach(el=>{setShadowClass(el),el.onscroll=function(){setShadowClass(this)}}),service.send("TABLE")},showSensorWizard:function(page){console.log("showSensorWizard: "+page),service.send(page)}});app.router=new Router,Backbone.history.start();let backboneHistoryFragment=Backbone.history.getFragment();-1!==backboneHistoryFragment.indexOf("wizard")&&($("#sensorWizardModal").modal("show"),-1!==backboneHistoryFragment.indexOf("sensor")?app.machine.context.nodeHistoryFragment="sensor/"+app.session.snid:app.machine.context.nodeHistoryFragment="table"),app.headLeftBtn.onclick=void 0,app.headLeftBtn.addEventListener("click",function(){screenMax(SCREEN_MAX_WIDTH_PHONE_LANDSCAPE)&&isThisPortrait()&&document.location.hash.indexOf("sensor/")>0?app.router.navigate("table",{trigger:!0}):openNav()}),document.querySelectorAll("[data-modal]").forEach(elem=>{elem.addEventListener("click",function(e){let el=e.currentTarget;if(!el)return;let ev=el.getAttribute("data-btn-ev");service.send(ev)})}),app.sensors.on("add",function(sn){app.session.snid=sn.id,machine.context.noteSn.id=sn.id,machine.context.service.send({type:DEVICE_ADDED,device:sn})},this),app.api.on("sensor-added",function(sn){app.session.snid=sn.id,machine.context.noteSn.id=sn.id,machine.context.service.send({type:DEVICE_ADDED,device:sn})},this),loadLanguage()}function getMachineFunctions(s,getPageContent,translatePage,installFunctions){return{enableSensorSearch:s.enableSensorSearch,disableSensorSearch:s.disableSensorSearch,renameDevice:s.renameDevice,getPageContent:getPageContent,translatePage:translatePage,routeToDetails:routeToDetails,setShadowClass:setShadowClass,initPages:initPages}}function routeToDetails(ctx,event){ctx.noteSn&&ctx.noteSn.id&&(app.router.navigate("sensor/"+ctx.noteSn.id,{trigger:!0}),ctx.noteSn.id=void 0)}function getPageActions(actions){return{...actions,[c.CALL_FUNC]:callFunc}}function deleteSensor(sn){sn&&(sn.destroy(),app.router.navigate("table",{trigger:!0}))}function locationHashChanged(e){let oldHash=e.oldURL.split("#")[1],newHash=e.newURL.split("#")[1];oldHash&&newHash&&-1!==oldHash.indexOf("scan")&&-1==newHash.indexOf("scan")&&scanFunctions.disableSensorSearch()}function setContextMenuListener(elem){if(elem.classList.contains("hide"))return void setTimeout(()=>{setContextMenuListener(elem)},100);let icon=elem.querySelector(".context-menu-icon"),menu=elem.querySelector(".context-menu"),outer=elem.querySelector(".context-menu-outer");"true"!==icon.getAttribute("listener")&&icon.addEventListener("click",ev=>{let el=ev.currentTarget.parentNode;el&&(icon.setAttribute("listener","true"),el.classList.contains("show-context")?el.classList.remove("show-context"):el.classList.add("show-context"))}),"true"!==menu.getAttribute("listener")&&(menu.addEventListener("click",ev=>{let el=ev.currentTarget.parentNode;el&&(menu.setAttribute("listener","true"),el.classList.remove("show-context"))}),outer.addEventListener("click",ev=>{let el=ev.currentTarget.parentNode;el&&el.classList.remove("show-context")}))}initApp(),restGetResource(app.config).then(()=>restGetResource(app.sensors)).then(res=>{setTimeout(()=>app.poll.pollRepeated(app.config),5e3),setTimeout(()=>app.poll.pollRepeated(app.sensors),5e3),app.sensorScan.fetch(),initViewAndLogic()}),$(document).on("show.bs.modal","#deleteSensorModal",function(){var sn=app.sensors.get(app.session.snid),name=sn.get("name");this.querySelector(".modal-body span b").innerText=name,this.querySelector(".modal-footer .btn-primary").addEventListener("click",function(){deleteSensor(sn)})}),window.onhashchange=locationHashChanged;