/*! phoscon-app 2024-10-07 */

import*as helperFunctions from"./helper-functions.js";export const getView=constants=>{let scheduleListView,navView,sceneListView,sceneListPhoneView;const OverviewView=Backbone.View.extend({el:"#overview",template:_.template(document.getElementById("group-time-overview-template").innerHTML),initialize:function(){this.service=null,this.el.innerHTML=this.template(),this.menuBtnIcon=document.querySelector("#menu-btn svg use"),this.menuBtnLabel=document.querySelector("#menu-btn span"),this.scheduleHeadline=document.querySelector("#scheduleNameHeadlineText"),this.createScheduleModal=$("#createScheduleModal"),this.timeInput=this.el.querySelector("#timeInput"),this.timerContainer=this.el.querySelector("#timer-container"),this.timerHour=this.el.querySelector("#timerInputHour"),this.timerMinute=this.el.querySelector("#timerInputMinute"),this.weekDaysContainer=this.el.querySelector("#selectWeekDays"),this.textStartDay=this.el.querySelector("#startDay"),this.buttonActivate=this.el.querySelector("#activateScheduleBtn"),this.textActivationStarts=this.el.querySelector("#scheduleActivationStarts"),this.textActivationEnds=this.el.querySelector("#scheduleActivationEnds"),this.toggleActivation=this.el.querySelector("#sch-toggle"),this.toggleActivationDiv=this.el.querySelector(".sch-toggle"),this.sliderFadingTime=this.el.querySelector("#scheduleSliderFadingTime"),this.sceneFadingTime=this.el.querySelector("#schedule_scene_fadingTime"),this.FadingTimeSceneContainer=this.el.querySelector(".schedule_scene_fadingTime_div"),this.FadingTimeGroupContainer=this.el.querySelector(".schedule_group_controls"),this.scheduleSettingsContainer=this.el.querySelector(".time-part"),this.fadingTimeGroupText=this.el.querySelector("#scheduleFadingCustomInput"),this.btnGroupOff=this.el.querySelector("#group_off_btn"),this.sceneList=this.el.querySelector("#sceneListMain"),this.mainView=this.el.querySelector(".main"),this.navView=document.querySelector("#navigation"),this.actionsSelect=this.el.querySelector("#actionsSelect"),this.sceneSelectPhone=this.el.querySelector("#main-scene-phone"),this.dotMenu=document.querySelector("#dotMenu .context-menu-icon"),this.dotIcon=this.dotMenu.parentNode;let injectOptions=SVGInject.setOptions({useCache:!1,copyAttributes:!0,makeIdsUnique:!1}),iconImg=this.el.querySelectorAll(".item-icon");SVGInject(iconImg,injectOptions),navView=new NavView,scheduleListView=new ScheduleListView,sceneListView=new SceneListView,sceneListPhoneView=new SceneListPhoneView,this.render()},render:function(e){return screenMax(SCREEN_MAX_WIDTH_TABLET_PORTRAIT)&&isThisPortrait()&&(this.mainView.classList.add("page-right"),setTimeout(()=>{this.actionsSelect.querySelector("option:first-child").innerHTML=translate("group_lights_off"),this.actionsSelect.querySelector("optgroup").innerHTML=translate("text_call_scene")},1e3)),this},addSchedule:function(){this.createScheduleModal.modal("show")},sceneSelected:function(){this.FadingTimeSceneContainer.classList.remove("hidden"),this.FadingTimeGroupContainer.classList.add("hidden"),this.sceneFadingTime.innerHTML=secondsToMinutesText(app.curSchedule.fadingtime)},groupOffSelected:function(){this.FadingTimeSceneContainer.classList.add("hidden"),this.FadingTimeGroupContainer.classList.remove("hidden")},adaptFadingTimeText:function(){this.fadingTimeGroupText.innerHTML=secondsToMinutesText(app.curSchedule.fadingtime)},adaptFadingTimeSlider:function(){let maxValue;if((maxValue=60*parseInt(app.curSchedule.hour)*60+60*parseInt(app.curSchedule.minute)-10)>3600||"start"===app.curSchedule.activation)this.sliderFadingTime.setAttribute("max",17);else{for(let i=0;i<18;i++)if(3600===maxValue||maxValue<app.timeSliderValues[i]){maxValue=i-1;break}this.sliderFadingTime.setAttribute("max",maxValue)}maxValue<=0?(maxValue=0,this.sliderFadingTime.setAttribute("disabled",!0),this.FadingTimeGroupContainer.classList.add("text-faded")):(this.sliderFadingTime.removeAttribute("disabled"),this.FadingTimeGroupContainer.classList.remove("text-faded"))},displayScheduleSettings:function(model){app.currentSite="SCHEDULE_SETTINGS",screenMax(SCREEN_MAX_WIDTH_PHONE_LANDSCAPE)&&isThisPortrait()&&(this.mainView.classList.remove("page-right"),this.navView.classList.add("page-left"),this.menuBtnIcon.setAttribute("xlink:href","#back-icon-sm"),this.menuBtnLabel.innerText=translate("text_back"));let scheduleType=constants.types.ALARM;if(-1!==model.get("time").indexOf("P")&&(scheduleType=constants.types.TIMER),scheduleType===constants.types.ALARM){let time=app.curSchedule.hour+":"+app.curSchedule.minute;this.timeInput.classList.remove("hidden"),this.timerContainer.classList.add("hidden"),this.timeInput.value=time.substr(time.indexOf("T")+1,5),this.timerContainer.parentElement.parentElement.classList.remove("timer")}else this.timeInput.classList.add("hidden"),this.timerContainer.classList.remove("hidden"),this.timerHour.value=app.curSchedule.hour,this.timerMinute.value=app.curSchedule.minute,this.timerContainer.parentElement.parentElement.classList.add("timer");this.scheduleHeadline.innerText=model.get("name");let headline=Snap("#scheduleNameHeadline").parent(),icon=scheduleType===constants.types.ALARM?Snap("#common-icons #schedule-icon").parent().clone():Snap("#common-icons #egg-timer-icon").parent().clone(),oldIcon=headline.select("svg:not(#renameSvg)");if(oldIcon&&oldIcon.remove(),headline.prepend(icon),scheduleType===constants.types.TIMER)this.weekDaysContainer.classList.add("hidden"),this.textStartDay.classList.add("hidden");else{this.weekDaysContainer.classList.remove("hidden"),this.textStartDay.classList.remove("hidden"),this.weekDaysContainer.querySelectorAll("button").forEach(btn=>{btn.classList.remove("btn-primary")});for(let i=1;i<=7;i++)"1"===app.curSchedule.days.charAt(i)&&this.weekDaysContainer.querySelector('[data-day="'+i+'"]').classList.add("btn-primary")}"start"===model.get("activation")?(this.textActivationStarts.style.fontWeight="bold",this.textActivationEnds.style.fontWeight="normal",this.toggleActivation.checked=!1):(this.textActivationStarts.style.fontWeight="normal",this.textActivationEnds.style.fontWeight="bold",this.toggleActivation.checked=!0),"group"===app.curSchedule.action?(this.FadingTimeSceneContainer.classList.add("hidden"),this.FadingTimeGroupContainer.classList.remove("hidden"),this.fadingTimeGroupText.innerHTML=secondsToMinutesText(app.curSchedule.fadingtime)):(this.FadingTimeSceneContainer.classList.remove("hidden"),this.FadingTimeGroupContainer.classList.add("hidden"),this.sceneFadingTime.innerHTML=secondsToMinutesText(app.curSchedule.fadingtime));let maxValue,s_h=parseInt(app.curSchedule.hour),s_min=parseInt(app.curSchedule.minute);if("alarm"===app.curSchedule.type)this.sliderFadingTime.setAttribute("max",17),this.sliderFadingTime.removeAttribute("disabled"),this.FadingTimeGroupContainer.classList.remove("text-faded");else{if((maxValue=60*s_h*60+60*s_min-10)>3600)this.sliderFadingTime.setAttribute("max",17);else{for(let i=0;i<18;i++)if(3600===maxValue||maxValue<app.timeSliderValues[i]){maxValue=i-1;break}this.sliderFadingTime.setAttribute("max",maxValue)}maxValue<=0?(maxValue=0,this.sliderFadingTime.setAttribute("disabled",!0),this.FadingTimeGroupContainer.classList.add("text-faded")):(this.sliderFadingTime.removeAttribute("disabled"),this.FadingTimeGroupContainer.classList.remove("text-faded"))}if(this.sliderFadingTime.value=app.timeSliderValues.indexOf(app.curSchedule.fadingtime),void 0!==app.curSchedule.originalFadingtime?this.fadingTimeGroupText.innerHTML=secondsToMinutesText(app.curSchedule.originalFadingtime):this.fadingTimeGroupText.innerHTML=secondsToMinutesText(app.curSchedule.fadingtime),screenMax(SCREEN_MAX_WIDTH_TABLET_PORTRAIT)&&isThisPortrait())"group"===app.curSchedule.action?this.actionsSelect.value="group_off":void 0!==app.curSchedule.sceneId&&(this.actionsSelect.value=app.curSchedule.sceneId);else{if(this.sceneList.querySelectorAll("li").forEach(btn=>{btn.classList.remove("active-item")}),this.btnGroupOff.classList.remove("active-item"),"group"===app.curSchedule.action)this.btnGroupOff.classList.add("active-item");else if(void 0!==app.curSchedule.sceneId){this.sceneList.querySelector('[data-sid="'+app.curSchedule.sceneId+'"').classList.add("active-item")}}"enabled"===model.get("status")?(this.buttonActivate.classList.remove("btn-primary"),this.buttonActivate.innerText="alarm"===app.curSchedule.type?translate("btn_deactivate_alarm"):translate("btn_stop_timer"),"timer"===app.curSchedule.type&&this.clickEvents(!1)):(this.clickEvents(!0),this.buttonActivate.classList.add("btn-primary"),this.buttonActivate.innerText="alarm"===app.curSchedule.type?translate("btn_activate_alarm"):translate("btn_start_timer")),scheduleType===constants.types.ALARM?(this.buttonActivate.classList.remove("timer"),this.sceneSelectPhone.classList.remove("timer"),this.clickEvents(!0)):(this.buttonActivate.classList.add("timer"),this.sceneSelectPhone.classList.add("timer")),setTimeout(()=>{"enabled"===model.get("status")?this.buttonActivate.innerText="alarm"===app.curSchedule.type?translate("btn_deactivate_alarm"):translate("btn_stop_timer"):this.buttonActivate.innerText="alarm"===app.curSchedule.type?translate("btn_activate_alarm"):translate("btn_start_timer")},250)},toggleActivationText:function(begins){!0===begins?(this.textActivationStarts.style.fontWeight="bold",this.textActivationEnds.style.fontWeight="normal"):(this.textActivationStarts.style.fontWeight="normal",this.textActivationEnds.style.fontWeight="bold")},setScheduleActivated:function(){this.buttonActivate.classList.remove("btn-primary"),this.buttonActivate.innerText="alarm"===app.curSchedule.type?translate("btn_deactivate_alarm"):translate("btn_stop_timer")},setScheduleDeactivated:function(){this.buttonActivate.classList.add("btn-primary"),this.buttonActivate.innerText="alarm"===app.curSchedule.type?translate("btn_activate_alarm"):translate("btn_start_timer")},adaptTodayOrTomorrowText:function(){"00000000"!==app.curSchedule.days?this.textStartDay.innerText=translate("text_repetition"):!0===helperFunctions.checkTimeInPast()?(this.textStartDay.setAttribute("data-translateid","text_onetime_tomorrow"),this.textStartDay.innerText=translate("text_onetime_tomorrow")):(this.textStartDay.setAttribute("data-translateid","text_onetime_today"),this.textStartDay.innerText=translate("text_onetime_today"))},weekDaySelected:function(day){let buttonClicked=this.weekDaysContainer.querySelector('[data-day="'+day+'"]');buttonClicked.classList.contains("btn-primary")?buttonClicked.classList.remove("btn-primary"):buttonClicked.classList.add("btn-primary")},clickEvents:function(enabled){!0===enabled?(this.toggleActivationDiv.style.pointerEvents="auto",this.timeInput.style.pointerEvents="auto",this.timeInput.style.backgroundColor="#ffffff",this.timeInput.style.color="#000000",this.timerHour.style.pointerEvents="auto",this.timerHour.style.backgroundColor="#ffffff",this.timerHour.style.color="#000000",this.timerMinute.style.pointerEvents="auto",this.timerMinute.style.backgroundColor="#ffffff",this.timerMinute.style.color="#000000",this.sliderFadingTime.style.pointerEvents="auto",this.sceneList.style.pointerEvents="auto",this.actionsSelect.style.pointerEvents="auto",this.actionsSelect.style.backgroundColor="#ffffff",this.actionsSelect.style.color="#000000",this.dotIcon.style.pointerEvents="auto","timer"===app.curSchedule.type&&(this.buttonActivate.classList.add("btn-primary"),this.buttonActivate.innerText=translate("btn_start_timer"))):(this.toggleActivationDiv.style.pointerEvents="none",this.timeInput.style.pointerEvents="none",this.timeInput.style.backgroundColor="#e7e7e7",this.timeInput.style.color="#707070",this.timerHour.style.pointerEvents="none",this.timerHour.style.backgroundColor="#e7e7e7",this.timerHour.style.color="#707070",this.timerMinute.style.pointerEvents="none",this.timerMinute.style.backgroundColor="#e7e7e7",this.timerMinute.style.color="#707070",this.sliderFadingTime.style.pointerEvents="none",this.sceneList.style.pointerEvents="none",this.actionsSelect.style.pointerEvents="none",this.actionsSelect.style.backgroundColor="#e7e7e7",this.actionsSelect.style.color="#707070",this.dotIcon.style.pointerEvents="none","timer"===app.curSchedule.type&&(this.buttonActivate.classList.remove("btn-primary"),this.buttonActivate.innerText=translate("btn_stop_timer")))},backToScheduleList:function(){this.navView.classList.remove("page-left"),this.mainView.classList.add("page-right"),app.currentSite="NAV_SCHEDULES",app.router.navigate("/",{trigger:!0})},events:{"click [data-btn-ev]":function(event){event.target.dataset.btnEv===constants.events.ACTIVATE_CLICKED?this.buttonActivate.classList.contains("btn-primary")?this.service.send({type:constants.events.ACTIVATE_SCHEDULE}):this.service.send({type:constants.events.DEACTIVATE_SCHEDULE}):this.service.send({type:event.target.dataset.btnEv})},"click #selectWeekDays button":function(event){let day=event.target.dataset.day||event.target.parentElement.dataset.day;this.service.send({type:constants.events.WEEKDAY_CLICKED,day:day})},"input #scheduleSliderFadingTime":function(event){this.service.send({type:constants.events.FADING_TIME_CHANGED,value:event.currentTarget.value})},"input #timeInput, #timerInputHour, #timerInputMinute":function(event){this.service.send({type:constants.events.TIME_CHANGED,value:event.currentTarget.value})},"change #sch-toggle":function(event){this.service.send({type:constants.events.TOGGLE_FADING,value:event.currentTarget.checked})},"click #menu-btn":function(event){this.backToScheduleList()},"click #dotMenu":function(event){this.dotIcon.classList.contains("show-context")?this.dotIcon.classList.remove("show-context"):this.dotIcon.classList.add("show-context")}},show:function(){this.el.classList.remove("hide")},hide:function(){this.el.classList.add("hide")}}),NavView=Backbone.View.extend({el:"#navigation",template:_.template(document.getElementById("group-time-nav-template").innerHTML),initialize:function(){this.el.innerHTML=this.template(),this.scheduleList=this.el.querySelector("#scheduleList"),this.addScheduleBtn=this.el.querySelector("#addSchedule"),this.goToGroupBackBtn=this.el.querySelector(".nav-head"),this.noSchedulesInfo=this.el.querySelector("#noSchedulesInfo"),this.render()},render:function(e){this.el.classList.remove("content-fade"),this.el.classList.remove("content-fade-0")},showEmptyState:function(){this.noSchedulesInfo.classList.remove("hide")},hideEmptyState:function(){this.noSchedulesInfo.classList.add("hide")},events:{"click [data-btn-ev]":function(event){this.service.send({type:event.target.dataset.btnEv})},"click #backToGroupBtn":function(event){let path=sessionStorage.getItem("app.index.path")||"index.html",param=sessionStorage.getItem("app.index.hash")||"#control/group/"+app.session.gid;location.assign(path+param)}}}),ScheduleListView=Backbone.View.extend({el:"#schedulesList",collection:app.schedules,initialize:function(){this.listenTo(this.collection,"add",this.addOne),this.listenTo(this.collection,"remove",this.removeOne),this.views=[],this.service=null,this.navigation=document.querySelector("#navigation"),this.overview=document.querySelector("#overview"),this.settings=document.querySelector("#settings"),this.menuBtnIcon=document.querySelector("#menu-btn svg use"),this.menuBtnLabel=document.querySelector("#menu-btn span"),this.collection.forEach(this.addOne,this)},setActiveSchedule:function(){this.service.send({type:constants.events.SCHEDULE_SELECTED})},setScheduleActivated:function(){this.el.querySelector('[data-sid="'+app.session.sid+'"]').classList.remove("disabled")},setScheduleDeactivated:function(){this.el.querySelector('[data-sid="'+app.session.sid+'"]').classList.add("disabled")},addOne:function(model){if(model.attributes.command.address.split("/")[4]==app.session.gid){var view=new ScheduleListItemView({model:model});this.el.append(view.render().el),this.views.push(view)}},removeOne:function(model){let views=this.views.filter(v=>v.model.get("id")!==model.get("id"));this.views=views,0===this.views.length&&this.service.send({type:"EMPTY"})}}),ScheduleListItemView=Backbone.View.extend({tagName:"li",template:_.template(document.getElementById("schedule-item-template").innerHTML),initialize:function(){this.model.on("change",this.render,this),this.model.on("destroy",this.remove,this),this.el.innerHTML=this.template(this.model.attributes),this.nameLabel=this.el.querySelector(".item-name"),this.endTimeLabel=this.el.querySelector(".endtime"),this.nameTimeContainer=this.el.querySelector(".schedule-name-time-container"),this.el.classList.add("list-group-item"),this.el.setAttribute("type","button"),this.el.setAttribute("data-sid",this.model.id),this.scheduleNameHeadline=document.querySelector("#scheduleNameHeadlineText"),this.service=null,this.render()},setActive:function(scheduleListView){scheduleListView.views.forEach(view=>{view.el.classList.remove("active-item")}),this.el.classList.add("active-item")},events:{click:function(ev){const elem=ev.currentTarget;app.session.sid=elem.dataset.sid,this.service.send({type:constants.events.SCHEDULE_SELECTED,view:this})}},render:function(service){this.scheduleNameHeadline.innerText=this.model.get("name");let scheduleType=-1!==this.model.get("time").indexOf("P")?constants.types.TIMER:constants.types.ALARM;if("disabled"===this.model.get("status")?(this.el.classList.add("disabled"),scheduleType===constants.types.TIMER&&(this.endTimeLabel.style.display="none",this.nameTimeContainer.classList.add("inactiveTimer"))):this.nameTimeContainer.classList.remove("inactiveTimer"),scheduleType===constants.types.ALARM&&(this.nameTimeContainer.classList.add("alarm"),this.model.get("localtime"))){let days=helperFunctions.getScheduleDays(this.model.get("localtime"),!1),fadingtime=helperFunctions.getScheduleFadingTime(this.model.attributes),timeArray=this.model.get("localtime").split("T")[1].split(":"),alarmTime=new Date;alarmTime.setHours(timeArray[0],timeArray[1],timeArray[2]);var normalisedTime=alarmTime;"end"===this.model.attributes.activation&&(normalisedTime=new Date(alarmTime.getTime()+1e3*fadingtime));let promise=[helperFunctions.weekBitmapToText(days)];Promise.all(promise).then(daysText=>{this.endTimeLabel.innerText=daysText+" "+helperFunctions.toTimeString(normalisedTime.getHours(),normalisedTime.getMinutes())})}if(scheduleType===constants.types.TIMER)if(this.el.querySelector("#timerIcon").classList.remove("hide"),"enabled"===this.model.get("status")){this.endTimeLabel.style.display="block";let startDate=new Date(this.model.get("starttime")),offset=(new Date).getTimezoneOffset(),startDateLocal=new Date(startDate.getTime()-6e4*offset),durationMs=0,dAr=this.model.get("time").slice(2).split(":");durationMs=parseInt(60*dAr[0]*6e4)+6e4*parseInt(dAr[1])+1e3*parseInt(dAr[2]);let endDate=new Date(startDateLocal.getTime()+durationMs);this.endTimeLabel.innerText=translate("text_activation_starts")+" "+helperFunctions.toTimeString(endDate.getHours(),endDate.getMinutes())}else service&&this.service.send({type:constants.events.TIMER_FINISHED});else this.el.querySelector("#alarmIcon").classList.remove("hide");return this.nameLabel.innerText=this.model.get("name"),this}}),SceneListView=Backbone.View.extend({el:"#sceneListMain",collection:app.scenes,initialize:function(){this.listenTo(this.collection,"add",this.addOne),this.listenTo(this.collection,"remove",this.removeOne),this.views=[],this.service=null,this.collection.forEach(this.addOne,this)},events:{"click #group_off_btn":function(event){this.service.send({type:constants.events.GROUP_OFF,view:this})}},setGroupOff:function(){this.views.forEach(view=>{view.el.classList.remove("active-item")}),document.querySelector("#group_off_btn").classList.add("active-item")},addOne:function(model){var view=new SceneListItemView({model:model});this.el.append(view.render().el),this.views.push(view)},removeOne:function(model){let views=this.views.filter(v=>v.model.get("id")!==model.get("id"));this.views=views}}),SceneListItemView=Backbone.View.extend({tagName:"li",template:_.template(document.getElementById("scene-item-template").innerHTML),initialize:function(){this.model.on("change",this.render,this),this.model.on("destroy",this.remove,this),this.el.innerHTML=this.template(this.model.attributes),this.nameLabel=this.el.querySelector(".item-name"),this.el.classList.add("list-group-item"),this.el.setAttribute("type","button"),this.el.setAttribute("data-sid",this.model.id);let injectOptions=SVGInject.setOptions({useCache:!1,copyAttributes:!0,makeIdsUnique:!1}),iconImg=this.el.querySelector(".item-icon");SVGInject(iconImg,injectOptions),this.service=null,this.render()},setActive:function(sceneListView){sceneListView.views.forEach(view=>{view.el.classList.remove("active-item")}),document.querySelector("#group_off_btn").classList.remove("active-item"),this.el.classList.add("active-item")},events:{click:function(ev){const elem=ev.currentTarget;app.session.scid=elem.dataset.sid,this.service.send({type:constants.events.SCENE_SELECTED,view:this})}},render:function(){return this.nameLabel.textContent=this.model.attributes.name,this}}),SceneListPhoneView=Backbone.View.extend({el:"#actionsSelect",collection:app.scenes,initialize:function(){this.listenTo(this.collection,"add",this.addOne),this.listenTo(this.collection,"remove",this.removeOne),this.views=[],this.service=null,this.collection.forEach(this.addOne,this)},events:{change:function(event){"group_off"===event.currentTarget.value?this.service.send({type:constants.events.GROUP_OFF,view:this}):(app.session.scid=event.currentTarget.value,this.service.send({type:constants.events.SCENE_SELECTED,view:this}))}},addOne:function(model){var view=new SceneListPhoneItemView({model:model});this.el.append(view.render().el),this.views.push(view)},removeOne:function(model){let views=this.views.filter(v=>v.model.get("id")!==model.get("id"));this.views=views}}),SceneListPhoneItemView=Backbone.View.extend({tagName:"option",initialize:function(){this.model.on("change",this.render,this),this.model.on("destroy",this.remove,this),this.el.innerHTML=this.model.get("name"),this.el.setAttribute("value",this.model.id),this.service=null,this.render()},setActive:function(sceneListView){sceneListView.views.forEach(view=>{view.el.classList.remove("active-item")}),document.querySelector("#group_off_btn").classList.remove("active-item"),this.el.classList.add("active-item")},render:function(){return this}});return{overviewView:new OverviewView,navView:navView,scheduleListView:scheduleListView,sceneListView:sceneListView,sceneListPhoneView:sceneListPhoneView}};